#!/usr/bin/python
##############################################################################
#
# Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
#                    Bartlomiej Gorny <bartek@erp5.pl>
#                    Kevin Deldycke <kevin@nexedi.com>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import os
import logging
from ConfigParser import ConfigParser, NoOptionError

WIN = False
if os.name == 'nt':
  WIN = True

config = ConfigParser()

if WIN:
  config.read([os.path.join(os.path.dirname(__file__), 'oood.conf')])
else:
  config.read(['/etc/oood/oood.conf', 'oood.conf'])

###################################################################
# System config
###################################################################

oood_home = config.get('System', 'oood_home')
run_dir   = config.get('System', 'run_dir')
tmp_dir   = config.get('System', 'tmp_dir')
uno_path  = config.get('System', 'uno_path')
log_file  = config.get('System', 'log_file')
try:
  prog_dir = config.get('System', 'prog_dir')
except NoOptionError:
  prog_dir = uno_path

if WIN:
  oood_home = oood_home.replace('\\', '/')
  run_dir = run_dir.replace('\\', '/')
  tmp_dir = tmp_dir.replace('\\', '/')
  uno_path= uno_path.replace('\\', '/')
  log_file = log_file.replace('\\', '/')
  prog_dir = prog_dir.replace('\\', '/')

debug_mode = config.getboolean('System', 'debug_mode')
log_level = eval(config.get('System', 'log_level'))


###################################################################
# Server settings
###################################################################

server_host = config.get('Server', 'server_host')
server_port = config.getint('Server', 'server_port')
printer_name = config.get('Server', 'printer_name')


###################################################################
# Pool settings
###################################################################

pool_host             = config.get('Pool', 'pool_host')
pool_port_range_start = config.getint('Pool', 'pool_port_range_start')
instance_load_time    = config.getint('Pool', 'instance_load_time')
instance_timeout      = config.getint('Pool', 'instance_timeout')
virtual_display_id    = config.getint('Pool', 'virtual_display_id')


pool_size             = 1 # do not change this
