/*
#############################################################################

 Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
                    Jacek Medrzycki <jacek@erp5.pl>

 WARNING: This program as such is intended to be used by professional
 programmers who take the whole responsability of assessing all potential
 consequences resulting from its eventual inadequacies and bugs
 End users who are looking for a ready-to-use solution with commercial
 garantees and support are strongly adviced to contract a Free Software
 Service Company

 This program is Free Software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

#############################################################################
*/

package pl.erp5.ood;

import  java.io.*;

/*
 * 
 * 
 */
public class TestClient {
    
    /* helper method for reading file
     */
    private static byte[] readData(String fn) throws IOException {
        File f = new File(fn);
        BufferedInputStream bin = new BufferedInputStream(
                new FileInputStream(f));

        byte[] inData = new byte[(int)f.length()];   
        int b = 0;
        int ix=0;
        while (b!=-1){
            b = bin.read();
            if (b!=-1)
                inData[ix++]=(byte)b;
        }        
        return inData;
    }

    /* helper method for writing file
     */
    private static void writeData(String fn, byte[] outData) throws IOException{
        File f = new File(fn);
        BufferedOutputStream bout = new BufferedOutputStream(
                new FileOutputStream(f));

        for (int ix=0;ix<outData.length;ix++)
            bout.write(outData[ix]);
        bout.close();
    }    
    
    //converting *.doc document to *.pdf format:
    public static void main(String [] args){
        try{
            //instantiate OooDaemonClient with server url pointing to 
            //working oood server
            OooDaemonClient oc = new OooDaemonClient("http://192.168.20.192:8008");
            
            //read *.doc document from filesystem
            byte[] inData = readData("/home/jacekm/Dokumenty/cv.doc");
            
            //convert it to pdf format using oood sever
            byte[] outData = oc.generate(inData, "pdf");
            
            //write converted data to *.pdf document
            writeData("/home/jacekm/Dokumenty/cv.pdf", outData);

        }catch(OooDaemonException e){
            System.out.println(e.getErrorCode());
            e.printStackTrace();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
}
