#!/usr/bin/python
##############################################################################
#
# Copyright (c) 2002, 2006 Nexedi SARL and Contributors. All Rights Reserved.
#                    Bartlomiej Gorny <bartek@erp5.pl>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import sys
import xmlrpclib

import oood_common

def usage():
  print """
  Usage: python simple_client.py input_file_name [target_format]
  """

if len(sys.argv) not in (2, 3):
  usage()
  sys.exit(0)

sp=xmlrpclib.ServerProxy('http://localhost:8008')
input_file_name = sys.argv[1]
target_format = len(sys.argv) == 3 and sys.argv[2] or None
parts = input_file_name.split('.')
if len(parts) == 0:
  print "file must have a meaningful extension"
  sys.exit(0)
ext = parts[-1]
base_name = '.'.join(parts[:-1])
response = oood_common.responseFactory(sp.getAllowedTargetItemList(oood_common.Request(extension=ext)))
format_option_list = dict(enumerate(response.response_data))
choice = -1
option_values = range(len(format_option_list))
if not target_format:
  while choice not in option_values:
    for i in option_values:
      print i, ': ', format_option_list[i][1]
    choice = raw_input('enter your choice: ')
    try:
      choice = int(choice)
    except:
      pass
  target_format = format_option_list[choice][0]
else:
  for i in option_values:
    if format_option_list[i][0] == target_format:
      choice = i
      break
  if choice == -1:
    print 'Format %s not available for this type of file' % target_format
    sys.exit(0)
print "Generating %s from %s" % (format_option_list[choice][1], input_file_name)
data = open(input_file_name).read()
req = oood_common.Request(data=data, extension=target_format, filename=input_file_name)
response = sp.generate(req)
response = oood_common.responseFactory(response)
if response.code == 200:
  output_name = base_name + '.' + target_format
  print "Saving result as %s" % (output_name)
  open(output_name, 'w').write(response.data)
else:
  print 'Failed: ', response.message
